unit FiducialSettings;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, DeskWinCNC, Settings, ExtDlgs, UiTypes, Vcl.Mask;

type
  TFormFiducialSettings = class(TForm)
    ButtonClose: TBitBtn;
    GroupBoxFiducialSettings: TGroupBox;
    EditFiducial1X: TLabeledEdit;
    EditFiducial1Y: TLabeledEdit;
    EditFiducial2Y: TLabeledEdit;
    EditFiducial2X: TLabeledEdit;
    ButtonSetFiducial1: TBitBtn;
    ButtonSetFiducial2: TBitBtn;
    ImageFiducial1: TImage;
    ImageFiducial2: TImage;
    ButtonFiducial1Snap: TBitBtn;
    ButtonFiducial2Snap: TBitBtn;
    ButtonGotoFiducial1: TBitBtn;
    ButtonGotoFiducial2: TBitBtn;
    ImageNoSnap1: TImage;
    ImageNoSnap2: TImage;
    GroupBoxJogControl: TGroupBox;
    ButtonJogZMinus: TButton;
    ButtonJogZPlus: TButton;
    ButtonJogXMinus: TButton;
    ButtonJogYMinus: TButton;
    ButtonJogYPlus: TButton;
    ButtonJogXPlus: TButton;
    ButtonZMinus1: TButton;
    ButtonZPlus1: TButton;
    ButtonYMinus1: TButton;
    ButtonYPlus1: TButton;
    ButtonXMinus1: TButton;
    ButtonXPlus1: TButton;
    ButtonZMinus10: TButton;
    ButtonZPlus10: TButton;
    ButtonYMinus10: TButton;
    ButtonYPlus10: TButton;
    ButtonXMinus10: TButton;
    ButtonXPlus10: TButton;
    ButtonTestFiducial1: TBitBtn;
    ButtonTestFiducial2: TBitBtn;
    EditFiducial1SnapName: TLabeledEdit;
    EditFiducial2SnapName: TLabeledEdit;
    OpenPictureDialog1: TOpenDialog;
    CheckBoxDualFiducial: TCheckBox;
    CheckBoxEnableFiducial: TCheckBox;
    EditFiducial1Z: TLabeledEdit;
    EditFiducial2Z: TLabeledEdit;
    procedure UpdateButtons;
    procedure FormShow(Sender: TObject);
    procedure EditFiducial1XChange(Sender: TObject);
    procedure EditFiducial1YChange(Sender: TObject);
    procedure EditFiducial2XChange(Sender: TObject);
    procedure EditFiducial2YChange(Sender: TObject);
    procedure ButtonSetFiducial1Click(Sender: TObject);
    procedure ButtonSetFiducial2Click(Sender: TObject);
    procedure ButtonFiducial1SnapClick(Sender: TObject);
    procedure ButtonFiducial2SnapClick(Sender: TObject);
    procedure ButtonGotoFiducial1Click(Sender: TObject);
    procedure ButtonGotoFiducial2Click(Sender: TObject);
    procedure ButtonXPlus10Click(Sender: TObject);
    procedure ButtonXPlus1Click(Sender: TObject);
    procedure ButtonJogXPlusClick(Sender: TObject);
    procedure ButtonJogXMinusClick(Sender: TObject);
    procedure ButtonXMinus1Click(Sender: TObject);
    procedure ButtonXMinus10Click(Sender: TObject);
    procedure ButtonYPlus10Click(Sender: TObject);
    procedure ButtonYPlus1Click(Sender: TObject);
    procedure ButtonJogYPlusClick(Sender: TObject);
    procedure ButtonJogYMinusClick(Sender: TObject);
    procedure ButtonYMinus1Click(Sender: TObject);
    procedure ButtonYMinus10Click(Sender: TObject);
    procedure ButtonZPlus10Click(Sender: TObject);
    procedure ButtonZPlus1Click(Sender: TObject);
    procedure ButtonJogZPlusClick(Sender: TObject);
    procedure ButtonJogZMinusClick(Sender: TObject);
    procedure ButtonZMinus1Click(Sender: TObject);
    procedure ButtonZMinus10Click(Sender: TObject);
    procedure ButtonTestFiducial1Click(Sender: TObject);
    procedure ButtonTestFiducial2Click(Sender: TObject);
    procedure EditFiducial1SnapNameClick(Sender: TObject);
    procedure EditFiducial2SnapNameClick(Sender: TObject);
    procedure CheckBoxDualFiducialClick(Sender: TObject);
    procedure CheckBoxEnableFiducialClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EditFiducial1ZChange(Sender: TObject);
    procedure EditFiducial1ZKeyPress(Sender: TObject; var Key: Char);
    procedure EditFiducial2ZKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    Enabled: boolean;
  public
    { Public declarations }
  end;

var
  FormFiducialSettings: TFormFiducialSettings;

implementation

{$R *.dfm}

uses
  Main, CreateSnap, ImageIOVideo, FmxUtils, Image;

procedure TFormFiducialSettings.UpdateButtons;
begin
  Enabled := false;

  ButtonSetFiducial1.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSetFiducial2.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoFiducial1.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoFiducial2.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonFiducial1Snap.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonFiducial2Snap.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  GroupBoxJogControl.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  CheckBoxDualFiducial.Checked := BoardDualFiducial;
  CheckBoxEnableFiducial.Checked := BoardFiducialEnable;
  CheckBoxDualFiducial.Visible := BoardFiducialEnable;

  if BoardMetric then
  begin
    EditFiducial1X.Text := FloatToStrF(BoardFiducial1X, ffFixed, 10, 3);
    EditFiducial1Y.Text := FloatToStrF(BoardFiducial1Y, ffFixed, 10, 3);
    EditFiducial1Z.Text := FloatToStrF(BoardFiducial1Z, ffFixed, 10, 3);
    EditFiducial2X.Text := FloatToStrF(BoardFiducial2X, ffFixed, 10, 3);
    EditFiducial2Y.Text := FloatToStrF(BoardFiducial2Y, ffFixed, 10, 3);
    EditFiducial2Z.Text := FloatToStrF(BoardFiducial2Z, ffFixed, 10, 3);
  end
  else
  begin
    EditFiducial1X.Text := FloatToStrF(BoardFiducial1X / 25.4, ffFixed, 10, 4);
    EditFiducial1Y.Text := FloatToStrF(BoardFiducial1Y / 25.4, ffFixed, 10, 4);
    EditFiducial1Z.Text := FloatToStrF(BoardFiducial1Z / 25.4, ffFixed, 10, 4);
    EditFiducial2X.Text := FloatToStrF(BoardFiducial2X / 25.4, ffFixed, 10, 4);
    EditFiducial2Y.Text := FloatToStrF(BoardFiducial2Y / 25.4, ffFixed, 10, 4);
    EditFiducial2Z.Text := FloatToStrF(BoardFiducial2Z / 25.4, ffFixed, 10, 4);
  end;

  EditFiducial1SnapName.Text := BoardFiducial1SnapName;
  Try
    ImageFiducial1.Picture.Bitmap.LoadFromFile(ProjectPath + BoardFiducial1SnapName + '.bmp');
    ImageNoSnap1.Visible := false;
    ImageFiducial1.Visible := true;
    ButtonTestFiducial1.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  Except
    ImageFiducial1.Visible := false;
    ImageNoSnap1.Visible := true;
    ButtonTestFiducial1.Enabled := false;
  End;

  EditFiducial2SnapName.Text := BoardFiducial2SnapName;
  Try
    ImageFiducial2.Picture.Bitmap.LoadFromFile(ProjectPath + BoardFiducial2SnapName + '.bmp');
    ImageNoSnap2.Visible := false;
    ImageFiducial2.Visible := true;
    ButtonTestFiducial2.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  Except
    ImageFiducial2.Visible := false;
    ImageNoSnap2.Visible := true;
    ButtonTestFiducial2.Enabled := false;
  End;

  Enabled := true;
end;

procedure TFormFiducialSettings.ButtonGotoFiducial1Click(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  FormMain.UpdateVideoGridRulers;
  FormMain.UpdateButtons;

  FormMain.MoveBoardRelativeWithNozzleProtection(BoardFiducial1X, BoardFiducial1Y, BoardFiducial1Z, 0, CNCMaxStepsPerSecond);
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormFiducialSettings.ButtonGotoFiducial2Click(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  FormMain.UpdateVideoGridRulers;
  FormMain.UpdateButtons;

  FormMain.MoveBoardRelativeWithNozzleProtection(BoardFiducial2X, BoardFiducial2Y, BoardFiducial2Z, 0, CNCMaxStepsPerSecond);
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormFiducialSettings.ButtonFiducial1SnapClick(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  FormMain.UpdateVideoGridRulers;
  FormMain.UpdateButtons;

  if FormMain.CaptureDownlooking and FormMain.CaptureDownlooking and FormMain.CaptureDownlooking then
  begin
    if FormCreateSnap.CreateProjectSnap(FormMain.ImageDownlooking) then
    begin
      BoardFiducial1SnapName := ChangeFileExt(ExtractFileName(FormCreateSnap.FileName), '');
      ProjectEdited := true;
      UpdateButtons;
    end;
  end;
end;

procedure TFormFiducialSettings.ButtonFiducial2SnapClick(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  FormMain.UpdateVideoGridRulers;
  FormMain.UpdateButtons;

  if FormMain.CaptureDownlooking and FormMain.CaptureDownlooking and FormMain.CaptureDownlooking then
  begin
    if FormCreateSnap.CreateProjectSnap(FormMain.ImageDownlooking) then
    begin
      BoardFiducial2SnapName := ChangeFileExt(ExtractFileName(FormCreateSnap.FileName), '');
      ProjectEdited := true;
      UpdateButtons;
    end;
  end;
end;

procedure TFormFiducialSettings.ButtonSetFiducial1Click(Sender: TObject);
begin
  if MessageDlg('ARE YOU SURE YOU WANT TO CHANGE FIDUCIAL 1?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes then
  begin
    BoardFiducial1X := CNCXPos - CNCActualHomeX - BoardOriginX; // set position
    BoardFiducial1Y := CNCYPos - CNCActualHomeY - BoardOriginY;
    BoardFiducial1Z := CNCZPos - CNCHomeZ;
    ProjectEdited := true; // indicate  save required

    Enabled := false;

    if BoardMetric then
    begin
      EditFiducial1X.Text := FloatToStrF(BoardFiducial1X, ffFixed, 10, 3);
      EditFiducial1Y.Text := FloatToStrF(BoardFiducial1Y, ffFixed, 10, 3);
      EditFiducial1Z.Text := FloatToStrF(BoardFiducial1Z, ffFixed, 10, 3);
    end
    else
    begin
      EditFiducial1X.Text := FloatToStrF(BoardFiducial1X / 25.4, ffFixed, 10, 4);
      EditFiducial1Y.Text := FloatToStrF(BoardFiducial1Y / 25.4, ffFixed, 10, 4);
      EditFiducial1Z.Text := FloatToStrF(BoardFiducial1Z / 25.4, ffFixed, 10, 4);
    end;

    Enabled := true;
  end;
  UpdateButtons;
end;

procedure TFormFiducialSettings.ButtonSetFiducial2Click(Sender: TObject);
begin
  if MessageDlg('ARE YOU SURE YOU WANT TO CHANGE FIDUCIAL 2?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes then
  begin
    BoardFiducial2X := CNCXPos - CNCActualHomeX - BoardOriginX; // set position
    BoardFiducial2Y := CNCYPos - CNCActualHomeY - BoardOriginY;
    BoardFiducial2Z := CNCZPos - CNCHomeZ;
    ProjectEdited := true; // indicate  save required

    Enabled := false;
    if BoardMetric then
    begin
      EditFiducial2X.Text := FloatToStrF(BoardFiducial2X, ffFixed, 10, 3);
      EditFiducial2Y.Text := FloatToStrF(BoardFiducial2Y, ffFixed, 10, 3);
      EditFiducial2Z.Text := FloatToStrF(BoardFiducial2Z, ffFixed, 10, 3);
    end
    else
    begin
      EditFiducial2X.Text := FloatToStrF(BoardFiducial2X / 25.4, ffFixed, 10, 4);
      EditFiducial2Y.Text := FloatToStrF(BoardFiducial2Y / 25.4, ffFixed, 10, 4);
      EditFiducial2Z.Text := FloatToStrF(BoardFiducial2Z / 25.4, ffFixed, 10, 4);
    end;
    Enabled := true;
  end;
  UpdateButtons;
end;

procedure TFormFiducialSettings.ButtonTestFiducial1Click(Sender: TObject);
var
  B: TBitmap;
  X, Y, Correlation: double;
begin
  FiducialX := 0; // reset fiducials
  FiducialY := 0;

  ViewSelection := 0; // downlooking camera
  FormMain.UpdateVideoGridRulers;
  FormMain.UpdateButtons;

  B := TBitmap.Create; // prepare visual reference
  Try
    B.LoadFromFile(ProjectPath + BoardFiducial1SnapName + '.bmp');
  Except
  End;
  FormMain.ImageReference := CreateImageFromBitmap(B); // convert to PBitmap32
  B.Free;

  // ******************************************************************************

  if FormMain.MoveBoardRelativeWithNozzleProtection(BoardFiducial1X, BoardFiducial1Y, BoardFiducial1Z, 0, CNCMaxStepsPerSecond) then
  begin
    FormMain.Delay(DownlookingCameraSettlingDelay); // small delay

    if FormMain.CaptureDownlooking and FormMain.CaptureDownlooking and FormMain.CaptureDownlooking then
    begin
      FormMain.VisualCorrelation(0, DownlookingCameraEnlargementMM, false); // correlate image
      Correlation := FormMain.VisionCorrelation; // get results
      X := FormMain.VisionCentreX; // error im mm
      Y := FormMain.VisionCentreY;

      if (Correlation > 0) then // if image found
      begin
        if FormMain.MoveBoardRelative(BoardFiducial1X + X, BoardFiducial1Y + Y, BoardFiducial1Z, 0, CNCMaxStepsPerSecond) then
        begin
          Beep;
        end
        else
          MessageDlg('FAILED TO MOVE TO CENTRE!', mtError, [mbCancel], 0, mbCancel);
      end
      else
        MessageDlg('FIDUCAL 1 TEST FAILED!', mtInformation, [mbOk], 0, mbOk);
    end
    else
      MessageDlg('CAMERA FAILED!', mtError, [mbCancel], 0, mbCancel);
  end
  else
    MessageDlg('FAILED TO MOVE TO FIDUCIAL 1!', mtError, [mbCancel], 0, mbCancel);

  FreeImage(FormMain.ImageReference);

  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormFiducialSettings.ButtonTestFiducial2Click(Sender: TObject);
var
  B: TBitmap;
  X, Y, Correlation: double;
begin
  FiducialX := 0; // reset fiducials
  FiducialY := 0;

  ViewSelection := 0; // downlooking camera
  FormMain.UpdateVideoGridRulers;
  FormMain.UpdateButtons;

  B := TBitmap.Create; // prepare visual reference
  Try
    B.LoadFromFile(ProjectPath + BoardFiducial2SnapName + '.bmp');
  Except
  End;
  FormMain.ImageReference := CreateImageFromBitmap(B); // convert to PBitmap32
  B.Free;

  // ******************************************************************************

  if FormMain.MoveBoardRelativeWithNozzleProtection(BoardFiducial2X, BoardFiducial2Y, BoardFiducial2Z, 0, CNCMaxStepsPerSecond) then
  begin
    FormMain.Delay(DownlookingCameraSettlingDelay); // small delay

    if FormMain.CaptureDownlooking and FormMain.CaptureDownlooking and FormMain.CaptureDownlooking then
    begin
      FormMain.VisualCorrelation(0, DownlookingCameraEnlargementMM, false); // correlate image
      Correlation := FormMain.VisionCorrelation; // get results
      X := FormMain.VisionCentreX; // error im mm
      Y := FormMain.VisionCentreY;

      if (Correlation > 0) then // if image found
      begin
        if FormMain.MoveBoardRelative(BoardFiducial2X + X, BoardFiducial2Y + Y, BoardFiducial2Z, 0, CNCMaxStepsPerSecond) then
        begin
          Beep;
        end
        else
          MessageDlg('FAILED TO MOVE TO CENTRE!', mtError, [mbCancel], 0, mbCancel);
      end
      else
        MessageDlg('FIDUCAL 2 TEST FAILED!', mtInformation, [mbOk], 0, mbOk);
    end
    else
      MessageDlg('CAMERA FAILED!', mtError, [mbCancel], 0, mbCancel);
  end
  else
    MessageDlg('FAILED TO MOVE TO FIDUCIAL 2!', mtError, [mbCancel], 0, mbCancel);

  FreeImage(FormMain.ImageReference);
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormFiducialSettings.EditFiducial1SnapNameClick(Sender: TObject);
var
  FileName, FilePath: string;
begin
  OpenPictureDialog1.InitialDir := IncludeTrailingPathDelimiter(ProjectPath);
  OpenPictureDialog1.FileName := ChangeFileExt(BoardFiducial1SnapName, '');

  if OpenPictureDialog1.Execute then
  begin
    FileName := ExtractFileName(OpenPictureDialog1.FileName);
    FilePath := IncludeTrailingPathDelimiter(ExtractFilePath(OpenPictureDialog1.FileName));

    if FilePath <> ProjectPath then
    begin // if snap from different path
      if FileExists(ProjectPath + FileName) then
      begin
        if (MessageDlg('A SNAP WITH THIS NAME ALREADY EXISTS IN THE PROJECT.' + #$0d + 'DO YOU WANT TO OVERWRITE IT WITH THIS SNAP?', mtConfirmation,
          [mbYes, mbNo], 0, mbYes) = mrYes) then
        begin // if exists then prompt for overwrite

          if FileCopy(FilePath + FileName, ProjectPath + FileName) then
          begin
            BoardFiducial1SnapName := ChangeFileExt(ExtractFileName(OpenPictureDialog1.FileName), '');
          end
          else
            MessageDlg('FILE COPY ERROR!!', mtError, [mbCancel], 0, mbCancel)
        end;
      end
      else // else do blind copy
      begin
        FileCopy(FilePath + FileName, ProjectPath + FileName);
        BoardFiducial1SnapName := ChangeFileExt(ExtractFileName(OpenPictureDialog1.FileName), '');
        FiducialX := 0; // reset fiducials
        FiducialY := 0;
      end;
    end
    else
    begin
      BoardFiducial1SnapName := ChangeFileExt(ExtractFileName(OpenPictureDialog1.FileName), '');
    end;

    ProjectEdited := true;
  end;
  UpdateButtons;
end;

procedure TFormFiducialSettings.EditFiducial1XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      if BoardMetric then
        V := StrToFloat(EditFiducial1X.Text)
      else
        V := StrToFloat(EditFiducial1X.Text) * 25.4; // convert to metric

      if (V + CNCActualHomeX + BoardOriginX >= CNCMinX) and (V + CNCActualHomeX + BoardOriginX <= CNCMaxX) then
      // restrict range
      begin
        BoardFiducial1X := V; // update changes
        EditFiducial1X.Color := clWindow; // normal colour
        FiducialX := 0; // reset fiducials
        FiducialY := 0;
      end
      else
        EditFiducial1X.Color := clRed; // error colour
    except
      EditFiducial1X.Color := clRed; // error colour
    end;
    ProjectEdited := true; // indicate  save required
  end;
end;

procedure TFormFiducialSettings.EditFiducial1YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      if BoardMetric then
        V := StrToFloat(EditFiducial1Y.Text)
      else
        V := StrToFloat(EditFiducial1Y.Text) * 25.4; // convert to metric

      if (V + CNCActualHomeY + BoardOriginY >= CNCMinY) and (V + CNCActualHomeY + BoardOriginY <= CNCMaxY) then
      // restrict range
      begin
        BoardFiducial1Y := V; // update changes
        EditFiducial1Y.Color := clWindow; // normal colour
        FiducialX := 0; // reset fiducials
        FiducialY := 0;
      end
      else
        EditFiducial1Y.Color := clRed; // error colour
    except
      EditFiducial1Y.Color := clRed; // error colour
    end;
    ProjectEdited := true; // indicate  save required
  end;
end;

procedure TFormFiducialSettings.EditFiducial1ZChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      if BoardMetric then
        V := StrToFloat(EditFiducial1Z.Text)
      else
        V := StrToFloat(EditFiducial1Z.Text) * 25.4; // convert to metric

      if (V + CNCHomeZ >= CNCMinZ) and (V + CNCHomeZ <= CNCMaxZ) then
      // restrict range
      begin
        BoardFiducial1Z := V; // update changes
        EditFiducial1Z.Color := clWindow; // normal colour
        FiducialX := 0; // reset fiducials
        FiducialY := 0;
      end
      else
        EditFiducial1Z.Color := clRed; // error colour
    except
      EditFiducial1Z.Color := clRed; // error colour
    end;
    ProjectEdited := true; // indicate  save required
  end;
end;

procedure TFormFiducialSettings.EditFiducial1ZKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormFiducialSettings.EditFiducial2XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      if BoardMetric then
        V := StrToFloat(EditFiducial2X.Text)
      else
        V := StrToFloat(EditFiducial2X.Text) * 25.4; // convert to metric

      if (V + CNCActualHomeX + BoardOriginX >= CNCMinX) and (V + CNCActualHomeX + BoardOriginX <= CNCMaxX) then
      // restrict range
      begin
        BoardFiducial2X := V; // update changes
        EditFiducial2X.Color := clWindow; // normal colour
        FiducialX := 0; // reset fiducials
        FiducialY := 0;
      end
      else
        EditFiducial2X.Color := clRed; // error colour
    except
      EditFiducial2X.Color := clRed; // error colour
    end;
    ProjectEdited := true; // indicate  save required
  end;
end;

procedure TFormFiducialSettings.EditFiducial2YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      if BoardMetric then
        V := StrToFloat(EditFiducial2Y.Text)
      else
        V := StrToFloat(EditFiducial2Y.Text) * 25.4; // convert to metric

      if (V + CNCActualHomeY + BoardOriginY >= CNCMinY) and (V + CNCActualHomeY + BoardOriginY <= CNCMaxY) then
      // restrict range
      begin
        BoardFiducial2Y := V; // update changes
        EditFiducial2Y.Color := clWindow; // normal colour
        FiducialX := 0; // reset fiducials
        FiducialY := 0;
      end
      else
        EditFiducial2Y.Color := clRed; // error colour
    except
      EditFiducial2Y.Color := clRed; // error colour
    end;
    ProjectEdited := true; // indicate  save required
  end;
end;

procedure TFormFiducialSettings.EditFiducial2ZKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormFiducialSettings.EditFiducial2SnapNameClick(Sender: TObject);
var
  FileName, FilePath: string;
begin
  OpenPictureDialog1.InitialDir := IncludeTrailingPathDelimiter(ProjectPath);
  OpenPictureDialog1.FileName := ChangeFileExt(BoardFiducial1SnapName, '');

  if OpenPictureDialog1.Execute then
  begin
    FileName := ExtractFileName(OpenPictureDialog1.FileName);
    FilePath := IncludeTrailingPathDelimiter(ExtractFilePath(OpenPictureDialog1.FileName));

    if FilePath <> ProjectPath then
    begin // if snap from different path
      if FileExists(ProjectPath + FileName) then
      begin
        if (MessageDlg('A SNAP WITH THIS NAME ALREADY EXISTS IN THE PROJECT.' + #$0d + 'DO YOU WANT TO OVERWRITE IT WITH THIS SNAP?', mtConfirmation,
          [mbYes, mbNo], 0, mbYes) = mrYes) then
        begin // if exists then prompt for overwrite

          if FileCopy(FilePath + FileName, ProjectPath + FileName) then
          begin
            BoardFiducial2SnapName := ChangeFileExt(ExtractFileName(OpenPictureDialog1.FileName), '');
          end
          else
            MessageDlg('FILE COPY ERROR!!', mtError, [mbCancel], 0, mbCancel)
        end;
      end
      else // else do blind copy
      begin
        FileCopy(FilePath + FileName, ProjectPath + FileName);
        BoardFiducial2SnapName := ChangeFileExt(ExtractFileName(OpenPictureDialog1.FileName), '');
        FiducialX := 0; // reset fiducials
        FiducialY := 0;
      end;
    end
    else
    begin
      BoardFiducial2SnapName := ChangeFileExt(ExtractFileName(OpenPictureDialog1.FileName), '');
    end;

    ProjectEdited := true;
  end;
  UpdateButtons;
end;

procedure TFormFiducialSettings.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Save_Settings; // ensure the settings are saved first
end;

procedure TFormFiducialSettings.FormShow(Sender: TObject);
begin
  Self.Left := Screen.Width - Self.Width; // position at top right
  Self.Top := 0;

  UpdateButtons;
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
end;

procedure TFormFiducialSettings.ButtonXPlus1Click(Sender: TObject);
begin
  JogX := 1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonYMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonYMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonYPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonYPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonZMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonZMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonZPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonZPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.CheckBoxDualFiducialClick(Sender: TObject);
begin
  BoardDualFiducial := CheckBoxDualFiducial.Checked;
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormFiducialSettings.CheckBoxEnableFiducialClick(Sender: TObject);
begin
  BoardFiducialEnable := CheckBoxEnableFiducial.Checked;
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormFiducialSettings.ButtonJogXMinusClick(Sender: TObject);
begin
  JogX := -JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonJogXPlusClick(Sender: TObject);
begin
  JogX := JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonJogYMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := -JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonJogYPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonJogZMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonJogZPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonXMinus10Click(Sender: TObject);
begin
  JogX := -10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonXMinus1Click(Sender: TObject);
begin
  JogX := -1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFiducialSettings.ButtonXPlus10Click(Sender: TObject);
begin
  JogX := 10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

end.
