unit NozzleChanger;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, UiTypes, Vcl.Mask;

type
  TFormNozzleChanger = class(TForm)
    ButtonClose: TBitBtn;
    GroupBoxNozzleChangerSettings: TGroupBox;
    EditNozzleDown: TLabeledEdit;
    EditNozzleUp: TLabeledEdit;
    EditNozzleHorizontal: TLabeledEdit;
    RadioButtonRight: TRadioButton;
    RadioButtonRear: TRadioButton;
    RadioButtonFront: TRadioButton;
    GroupBoxNozzles: TGroupBox;
    EditNozzle1Y: TLabeledEdit;
    EditNozzle1X: TLabeledEdit;
    EditNozzle2Y: TLabeledEdit;
    EditNozzle2X: TLabeledEdit;
    EditNozzle3Y: TLabeledEdit;
    EditNozzle3X: TLabeledEdit;
    EditNozzle4Y: TLabeledEdit;
    EditNozzle4X: TLabeledEdit;
    EditNozzle5Y: TLabeledEdit;
    EditNozzle5X: TLabeledEdit;
    EditNozzle6X: TLabeledEdit;
    EditNozzle6Y: TLabeledEdit;
    EditNozzle7X: TLabeledEdit;
    EditNozzle7Y: TLabeledEdit;
    EditNozzle8X: TLabeledEdit;
    EditNozzle8Y: TLabeledEdit;
    ButtonSelectNozzle1: TButton;
    ButtonSelectNozzle2: TButton;
    ButtonSelectNozzle3: TButton;
    ButtonSelectNozzle4: TButton;
    ButtonSelectNozzle5: TButton;
    ButtonSelectNozzle6: TButton;
    ButtonSelectNozzle7: TButton;
    ButtonSelectNozzle8: TButton;
    EditNozzlePickDown: TLabeledEdit;
    CheckBoxNozzleChangerEnabled: TCheckBox;
    EditCurrentNozzle: TLabeledEdit;
    ButtonSetPosition: TButton;
    ButtonGotoPosition: TButton;
    ButtonParkNozzle: TButton;
    EditNozzleChangerSpeed: TLabeledEdit;
    GroupBoxJogControl: TGroupBox;
    ButtonJogZMinus: TButton;
    ButtonJogZPlus: TButton;
    ButtonJogXMinus: TButton;
    ButtonJogYMinus: TButton;
    ButtonJogYPlus: TButton;
    ButtonJogXPlus: TButton;
    ButtonZMinus1: TButton;
    ButtonZPlus1: TButton;
    ButtonYMinus1: TButton;
    ButtonYPlus1: TButton;
    ButtonXMinus1: TButton;
    ButtonXPlus1: TButton;
    ButtonZMinus10: TButton;
    ButtonZPlus10: TButton;
    ButtonYMinus10: TButton;
    ButtonYPlus10: TButton;
    ButtonXMinus10: TButton;
    ButtonXPlus10: TButton;
    procedure EditNozzleDownChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBoxNozzleChangerEnabledClick(Sender: TObject);
    procedure EditNozzle1XChange(Sender: TObject);
    procedure EditNozzle1YChange(Sender: TObject);
    procedure EditNozzle2XChange(Sender: TObject);
    procedure EditNozzle3XChange(Sender: TObject);
    procedure EditNozzle4XChange(Sender: TObject);
    procedure EditNozzle5XChange(Sender: TObject);
    procedure EditNozzle2YChange(Sender: TObject);
    procedure EditNozzle3YChange(Sender: TObject);
    procedure EditNozzle4YChange(Sender: TObject);
    procedure EditNozzle5YChange(Sender: TObject);
    procedure RadioButtonRightClick(Sender: TObject);
    procedure RadioButtonFrontClick(Sender: TObject);
    procedure RadioButtonRearClick(Sender: TObject);
    procedure ButtonSelectNozzle1Click(Sender: TObject);
    procedure ButtonSelectNozzle2Click(Sender: TObject);
    procedure ButtonSelectNozzle3Click(Sender: TObject);
    procedure ButtonSelectNozzle4Click(Sender: TObject);
    procedure ButtonSelectNozzle5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditCurrentNozzleKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonSetPositionClick(Sender: TObject);
    procedure ButtonGotoPositionClick(Sender: TObject);
    procedure ButtonParkNozzleClick(Sender: TObject);
    procedure EditNozzleUpChange(Sender: TObject);
    procedure EditNozzleHorizontalChange(Sender: TObject);
    procedure EditNozzleChangerSpeedChange(Sender: TObject);
    procedure ButtonXPlus10Click(Sender: TObject);
    procedure ButtonXPlus1Click(Sender: TObject);
    procedure ButtonJogXPlusClick(Sender: TObject);
    procedure ButtonJogXMinusClick(Sender: TObject);
    procedure ButtonXMinus1Click(Sender: TObject);
    procedure ButtonXMinus10Click(Sender: TObject);
    procedure ButtonYPlus10Click(Sender: TObject);
    procedure ButtonYPlus1Click(Sender: TObject);
    procedure ButtonJogYPlusClick(Sender: TObject);
    procedure ButtonJogYMinusClick(Sender: TObject);
    procedure ButtonYMinus1Click(Sender: TObject);
    procedure ButtonYMinus10Click(Sender: TObject);
    procedure ButtonZPlus10Click(Sender: TObject);
    procedure ButtonZPlus1Click(Sender: TObject);
    procedure ButtonJogZPlusClick(Sender: TObject);
    procedure ButtonJogZMinusClick(Sender: TObject);
    procedure ButtonZMinus1Click(Sender: TObject);
    procedure ButtonZMinus10Click(Sender: TObject);
    procedure ButtonJogAPlusClick(Sender: TObject);
    procedure EditNozzlePickDownChange(Sender: TObject);
    procedure ButtonSelectNozzle6Click(Sender: TObject);
    procedure ButtonSelectNozzle7Click(Sender: TObject);
    procedure ButtonSelectNozzle8Click(Sender: TObject);
    procedure EditNozzle6XChange(Sender: TObject);
    procedure EditNozzle7XChange(Sender: TObject);
    procedure EditNozzle8XChange(Sender: TObject);
    procedure EditNozzle6YChange(Sender: TObject);
    procedure EditNozzle7YChange(Sender: TObject);
    procedure EditNozzle8YChange(Sender: TObject);
  private
    { Private declarations }
    Enabled: boolean;
    procedure UpdateValues;
    procedure UpdateButtons;
  public
    { Public declarations }
    function ParkNozzle: boolean;
    function SelectNozzle(RequestedNozzle: integer): boolean;
  end;

var
  FormNozzleChanger: TFormNozzleChanger;

implementation

{$R *.dfm}

uses
  DeskWinCNC, Settings, Main;

procedure TFormNozzleChanger.UpdateButtons;
begin
  ButtonSelectNozzle1.Enabled := (CurrentNozzle <> 1) and NozzleChangerEnabled and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSelectNozzle2.Enabled := (CurrentNozzle <> 2) and NozzleChangerEnabled and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSelectNozzle3.Enabled := (CurrentNozzle <> 3) and NozzleChangerEnabled and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSelectNozzle4.Enabled := (CurrentNozzle <> 4) and NozzleChangerEnabled and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSelectNozzle5.Enabled := (CurrentNozzle <> 5) and NozzleChangerEnabled and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonSelectNozzle6.Enabled := (CurrentNozzle <> 6) and NozzleChangerEnabled and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSelectNozzle7.Enabled := (CurrentNozzle <> 7) and NozzleChangerEnabled and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSelectNozzle8.Enabled := (CurrentNozzle <> 8) and NozzleChangerEnabled and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonSetPosition.Enabled := (CurrentNozzle > 0) and NozzleChangerEnabled and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoPosition.Enabled := (CurrentNozzle > 0) and NozzleChangerEnabled and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonParkNozzle.Enabled := NozzleChangerEnabled and (CurrentNozzle > 0) and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  GroupBoxJogControl.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  if CurrentNozzle > 0 then
    EditCurrentNozzle.Text := IntToStr(CurrentNozzle) // update displayed nozzle
  else
    EditCurrentNozzle.Text := 'NONE';
end;

function TFormNozzleChanger.ParkNozzle: boolean;
var
  X, Y, OutX, OutY: double; // nozzle position and Directional offset
begin
  if CNCControllerFound and CNCInitialised and not CNCEmergencyStop then
  begin
    if CurrentNozzle > 0 then // if not parked
    begin // put back current nozzle
      X := 0; // defaults
      Y := 0;

      case CurrentNozzle of // set location of current nozzle
        1:
          begin
            X := Nozzle1X;
            Y := Nozzle1Y;
          end;
        2:
          begin
            X := Nozzle2X;
            Y := Nozzle2Y;
          end;
        3:
          begin
            X := Nozzle3X;
            Y := Nozzle3Y;
          end;
        4:
          begin
            X := Nozzle4X;
            Y := Nozzle4Y;
          end;
        5:
          begin
            X := Nozzle5X;
            Y := Nozzle5Y;
          end;
        6:
          begin
            X := Nozzle6X;
            Y := Nozzle6Y;
          end;
        7:
          begin
            X := Nozzle7X;
            Y := Nozzle7Y;
          end;
        8:
          begin
            X := Nozzle8X;
            Y := Nozzle8Y;
          end;
      end;

      OutX := 0; // defaults
      OutY := 0;
      Case NozzleChangerLocation of // 0 = right, 1 = front, 2 = rear
        0: // NozzleHorizontal, NozzleUp, NozzleDown
          begin
            OutX := -NozzleHorizontal;
            OutY := 0;
          end;
        1:
          begin
            OutX := 0;
            OutY := NozzleHorizontal;
          end;
        2:
          begin
            OutX := 0;
            OutY := -NozzleHorizontal;
          end;
      end;

      // ******************************************************************************

      if FormMain.MoveHomeRelativeWithNozzleProtection(X + OutX, Y + OutY, NozzleDown, 0, CNCMaxStepsPerSecond) then
      begin // now at nozzle entry position
        if FormMain.MoveHomeRelative(X, Y, NozzleDown, 0, NozzleChangerSpeed) then
        begin // now at nozzle position
          if FormMain.MoveHomeRelative(X, Y, -NozzleUp, 0, NozzleChangerSpeed) then
          begin
            CurrentNozzle := 0; // nozzle was returned
            Result := true; // success!!
          end
          else
            Result := false; // failed to move up to release nozzle
        end
        else
          Result := false; // failed to move to nozzle position
      end
      else
        Result := false; // failed to move to nozzle ENTRY HEIGHT
    end
    else
      Result := true; // already selected
  end
  else
    Result := false; // control is disabled

  Save_Status; { save status related settings }

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

function TFormNozzleChanger.SelectNozzle(RequestedNozzle: integer): boolean;
var
  X, Y, OutX, OutY: double; // nozzle position and Directional offset
begin
  if CNCControllerFound and CNCInitialised and not CNCEmergencyStop then
  begin
    if RequestedNozzle <> CurrentNozzle then // if not already selected
    begin
      if ParkNozzle then // put back current nozzle
      begin
        if (RequestedNozzle > 0) and (RequestedNozzle <= 8) then
        begin // if requested nozzle is a valid number then select new nozzle
          X := 0; // defaults
          Y := 0;
          case RequestedNozzle of // set location of requested nozzle
            1:
              begin
                X := Nozzle1X;
                Y := Nozzle1Y;
              end;
            2:
              begin
                X := Nozzle2X;
                Y := Nozzle2Y;
              end;
            3:
              begin
                X := Nozzle3X;
                Y := Nozzle3Y;
              end;
            4:
              begin
                X := Nozzle4X;
                Y := Nozzle4Y;
              end;
            5:
              begin
                X := Nozzle5X;
                Y := Nozzle5Y;
              end;
            6:
              begin
                X := Nozzle6X;
                Y := Nozzle6Y;
              end;
            7:
              begin
                X := Nozzle7X;
                Y := Nozzle7Y;
              end;
            8:
              begin
                X := Nozzle8X;
                Y := Nozzle8Y;
              end;
          end;

          OutX := 0; // defaults
          OutY := 0;
          Case NozzleChangerLocation of // 0 = right, 1 = front, 2 = rear
            0: // NozzleHorizontal, NozzleUp, NozzleDown
              begin
                OutX := -NozzleHorizontal;
                OutY := 0;
              end;
            1:
              begin
                OutX := 0;
                OutY := NozzleHorizontal;
              end;
            2:
              begin
                OutX := 0;
                OutY := -NozzleHorizontal;
              end;
          end;

          // ******************************************************************************

          if FormMain.MoveHomeRelativeWithNozzleProtection(X, Y, 0, 0, CNCMaxStepsPerSecond) then
          begin // now at nozzle entry position
            if FormMain.MoveHomeRelative(X, Y, NozzleDown + NozzlePickDown, 0, NozzleChangerSpeed) then
            begin // now down IN NOZZLE at PICK HEIGHT
              FormMain.Delay(0.25); // small delay to allow nozzle to settle
              if FormMain.MoveHomeRelative(X, Y, NozzleDown, 0, NozzleChangerSpeed) then
              begin // now down IN NOZZLE AT ENTRY HEIGHT
                FormMain.Delay(0.15); // small delay to allow nozzle to settle
                if FormMain.MoveHomeRelative(X + OutX, Y + OutY, NozzleDown, 0, NozzleChangerSpeed) then
                begin // now moved out with nozzle while down
                  if FormMain.MoveHomeRelative(X + OutX, Y + OutY, 0, 0, CNCMaxStepsPerSecond) then
                  begin // now moved out with nozzle while down
                    CurrentNozzle := RequestedNozzle; // nozzle was retreived
                    Result := true; // success!!
                  end
                  else
                    Result := false; // failed to move up to default height
                end
                else
                  Result := false; // failed to move out with nozzle
              end
              else
                Result := false;
              // failed to move back to exit height with nozzle
            end
            else
              Result := false; // failed to move down to pick up nozzle
          end
          else
            Result := false; // failed to move to nozzle ENTRY position
        end
        else
          Result := false; // invalid nozzle number
      end
      else
        Result := false; // failed to park nozzle
    end
    else
      Result := true; // already selected
  end
  else
    Result := false; // control is disabled

  Save_Status; { save status related settings }

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleChanger.ButtonGotoPositionClick(Sender: TObject);
begin
  if MessageDlg('WARNING! THIS CAN CAUSE MECHANICAL DAMAGE!!, ARE YOU SURE YOU WANT TO CONTINUE?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes then
  begin

    case CurrentNozzle of
      1:
        begin
          FormMain.MoveHomeRelativeWithNozzleProtection(Nozzle1X, Nozzle1Y, 0, 0, CNCMaxStepsPerSecond);
        end;
      2:
        begin
          FormMain.MoveHomeRelativeWithNozzleProtection(Nozzle2X, Nozzle2Y, 0, 0, CNCMaxStepsPerSecond);
        end;
      3:
        begin
          FormMain.MoveHomeRelativeWithNozzleProtection(Nozzle3X, Nozzle3Y, 0, 0, CNCMaxStepsPerSecond);
        end;
      4:
        begin
          FormMain.MoveHomeRelativeWithNozzleProtection(Nozzle4X, Nozzle4Y, 0, 0, CNCMaxStepsPerSecond);
        end;
      5:
        begin
          FormMain.MoveHomeRelativeWithNozzleProtection(Nozzle5X, Nozzle5Y, 0, 0, CNCMaxStepsPerSecond);
        end;
      6:
        begin
          FormMain.MoveHomeRelativeWithNozzleProtection(Nozzle6X, Nozzle6Y, 0, 0, CNCMaxStepsPerSecond);
        end;
      7:
        begin
          FormMain.MoveHomeRelativeWithNozzleProtection(Nozzle7X, Nozzle7Y, 0, 0, CNCMaxStepsPerSecond);
        end;
      8:
        begin
          FormMain.MoveHomeRelativeWithNozzleProtection(Nozzle8X, Nozzle8Y, 0, 0, CNCMaxStepsPerSecond);
        end;
    end;

    FormMain.UpdateStatus;
    FormMain.UpdateButtons;
    UpdateButtons;
  end;
end;

procedure TFormNozzleChanger.ButtonParkNozzleClick(Sender: TObject);
begin
  ParkNozzle;

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleChanger.ButtonSelectNozzle1Click(Sender: TObject);
begin
  SelectNozzle(1); // change nozzles

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleChanger.ButtonSelectNozzle2Click(Sender: TObject);
begin
  SelectNozzle(2); // change nozzles

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleChanger.ButtonSelectNozzle3Click(Sender: TObject);
begin
  SelectNozzle(3); // change nozzles

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleChanger.ButtonSelectNozzle4Click(Sender: TObject);
begin
  SelectNozzle(4); // change nozzles

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleChanger.ButtonSelectNozzle5Click(Sender: TObject);
begin
  SelectNozzle(5); // change nozzles

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleChanger.ButtonSelectNozzle6Click(Sender: TObject);
begin
  SelectNozzle(6); // change nozzles

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleChanger.ButtonSelectNozzle7Click(Sender: TObject);
begin
  SelectNozzle(7); // change nozzles

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleChanger.ButtonSelectNozzle8Click(Sender: TObject);
begin
  SelectNozzle(8); // change nozzles

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleChanger.ButtonSetPositionClick(Sender: TObject);
begin
  if MessageDlg('ARE YOU SURE YOU WANT TO CHANGE THE POSITION OF THIS NOZZLE?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes then
  begin
    case CurrentNozzle of
      1:
        begin
          Nozzle1X := CNCXPos - CNCActualHomeX;
          Nozzle1Y := CNCYPos - CNCActualHomeY;
        end;
      2:
        begin
          Nozzle2X := CNCXPos - CNCActualHomeX;
          Nozzle2Y := CNCYPos - CNCActualHomeY;
        end;
      3:
        begin
          Nozzle3X := CNCXPos - CNCActualHomeX;
          Nozzle3Y := CNCYPos - CNCActualHomeY;
        end;
      4:
        begin
          Nozzle4X := CNCXPos - CNCActualHomeX;
          Nozzle4Y := CNCYPos - CNCActualHomeY;
        end;
      5:
        begin
          Nozzle5X := CNCXPos - CNCActualHomeX;
          Nozzle5Y := CNCYPos - CNCActualHomeY;
        end;
      6:
        begin
          Nozzle6X := CNCXPos - CNCActualHomeX;
          Nozzle6Y := CNCYPos - CNCActualHomeY;
        end;
      7:
        begin
          Nozzle7X := CNCXPos - CNCActualHomeX;
          Nozzle7Y := CNCYPos - CNCActualHomeY;
        end;
      8:
        begin
          Nozzle8X := CNCXPos - CNCActualHomeX;
          Nozzle8Y := CNCYPos - CNCActualHomeY;
        end;
    end;

    UpdateValues;
    UpdateButtons;
  end;
end;

procedure TFormNozzleChanger.CheckBoxNozzleChangerEnabledClick(Sender: TObject);
begin
  NozzleChangerEnabled := CheckBoxNozzleChangerEnabled.Checked;
  GroupBoxNozzles.Enabled := NozzleChangerEnabled;
  FormMain.UpdateStatus;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditCurrentNozzleKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0;
  // cancel keystroke
end;

procedure TFormNozzleChanger.EditNozzle1XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle1X.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        Nozzle1X := V;
        EditNozzle1X.Color := clWindow; // normal colour
      end
      else
        EditNozzle1X.Color := clRed; // error colour
    except
      EditNozzle1X.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle1YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle1Y.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        Nozzle1Y := V;
        EditNozzle1Y.Color := clWindow; // normal colour
      end
      else
        EditNozzle1Y.Color := clRed; // error colour
    except
      EditNozzle1Y.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle2XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle2X.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        Nozzle2X := V;
        EditNozzle2X.Color := clWindow; // normal colour
      end
      else
        EditNozzle2X.Color := clRed; // error colour
    except
      EditNozzle2X.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle2YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle2Y.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        Nozzle2Y := V;
        EditNozzle2Y.Color := clWindow; // normal colour
      end
      else
        EditNozzle2Y.Color := clRed; // error colour
    except
      EditNozzle2Y.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle3XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle3X.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        Nozzle3X := V;
        EditNozzle3X.Color := clWindow; // normal colour
      end
      else
        EditNozzle3X.Color := clRed; // error colour
    except
      EditNozzle3X.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle3YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle3Y.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        Nozzle3Y := V;
        EditNozzle3Y.Color := clWindow; // normal colour
      end
      else
        EditNozzle3Y.Color := clRed; // error colour
    except
      EditNozzle3Y.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle4XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle4X.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        Nozzle4X := V;
        EditNozzle4X.Color := clWindow; // normal colour
      end
      else
        EditNozzle4X.Color := clRed; // error colour
    except
      EditNozzle4X.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle4YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle4Y.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        Nozzle4Y := V;
        EditNozzle4Y.Color := clWindow; // normal colour
      end
      else
        EditNozzle4Y.Color := clRed; // error colour
    except
      EditNozzle4Y.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle5XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle5X.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        Nozzle5X := V;
        EditNozzle5X.Color := clWindow; // normal colour
      end
      else
        EditNozzle5X.Color := clRed; // error colour
    except
      EditNozzle5X.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle5YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle5Y.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        Nozzle5Y := V;
        EditNozzle5Y.Color := clWindow; // normal colour
      end
      else
        EditNozzle5Y.Color := clRed; // error colour
    except
      EditNozzle5Y.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle6XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle6X.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        Nozzle6X := V;
        EditNozzle6X.Color := clWindow; // normal colour
      end
      else
        EditNozzle6X.Color := clRed; // error colour
    except
      EditNozzle6X.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle6YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle6Y.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        Nozzle6Y := V;
        EditNozzle6Y.Color := clWindow; // normal colour
      end
      else
        EditNozzle6Y.Color := clRed; // error colour
    except
      EditNozzle6Y.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle7XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle7X.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        Nozzle7X := V;
        EditNozzle7X.Color := clWindow; // normal colour
      end
      else
        EditNozzle7X.Color := clRed; // error colour
    except
      EditNozzle7X.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle7YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle7Y.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        Nozzle7Y := V;
        EditNozzle7Y.Color := clWindow; // normal colour
      end
      else
        EditNozzle7Y.Color := clRed; // error colour
    except
      EditNozzle7Y.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle8XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle8X.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        Nozzle8X := V;
        EditNozzle8X.Color := clWindow; // normal colour
      end
      else
        EditNozzle8X.Color := clRed; // error colour
    except
      EditNozzle8X.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzle8YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzle8Y.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        Nozzle8Y := V;
        EditNozzle8Y.Color := clWindow; // normal colour
      end
      else
        EditNozzle8Y.Color := clRed; // error colour
    except
      EditNozzle8Y.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzleChangerSpeedChange(Sender: TObject);
var
  V: integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditNozzleChangerSpeed.Text);
      if (V >= 0) and (V <= CNCMaxStepsPerSecond) then
      // restrict range
      begin
        NozzleChangerSpeed := V;
        EditNozzleChangerSpeed.Color := clWindow; // normal colour
      end
      else
        EditNozzleChangerSpeed.Color := clRed; // error colour
    except
      EditNozzleChangerSpeed.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzleDownChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzleDown.Text);
      if (V >= CNCMinZ) and (V <= CNCMaxZ) then
      // restrict range
      begin
        NozzleDown := V;
        EditNozzleDown.Color := clWindow; // normal colour
      end
      else
        EditNozzleDown.Color := clRed; // error colour
    except
      EditNozzleDown.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzleHorizontalChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzleHorizontal.Text);
      if (V >= 10) and (V <= 30) then
      // restrict range
      begin
        NozzleHorizontal := V;
        EditNozzleHorizontal.Color := clWindow; // normal colour
      end
      else
        EditNozzleHorizontal.Color := clRed; // error colour
    except
      EditNozzleHorizontal.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzlePickDownChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzlePickDown.Text);
      if (V >= 0) and (V <= 3) then
      // restrict range
      begin
        NozzlePickDown := V;
        EditNozzlePickDown.Color := clWindow; // normal colour
      end
      else
        EditNozzlePickDown.Color := clRed; // error colour
    except
      EditNozzlePickDown.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.EditNozzleUpChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditNozzleUp.Text);
      if (V >= CNCMinZ) and (V <= CNCMaxZ) then
      // restrict range
      begin
        NozzleUp := V;
        EditNozzleUp.Color := clWindow; // normal colour
      end
      else
        EditNozzleUp.Color := clRed; // error colour
    except
      EditNozzleUp.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleChanger.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  UpdateButtons;

  Save_Settings; // ensure the settings are saved first
end;

procedure TFormNozzleChanger.FormCreate(Sender: TObject);
begin
  Enabled := false;
end;

procedure TFormNozzleChanger.FormShow(Sender: TObject);
begin
  Self.Left := Screen.Width - Self.Width; // position at top right
  Self.Top := 0;

  UpdateValues;
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
end;

procedure TFormNozzleChanger.UpdateValues;
begin
  Enabled := false;

  CheckBoxNozzleChangerEnabled.Checked := NozzleChangerEnabled;

  EditNozzleHorizontal.Text := FloatToStrF(NozzleHorizontal, ffFixed, 10, 3);
  EditNozzleUp.Text := FloatToStrF(NozzleUp, ffFixed, 10, 3);
  EditNozzleDown.Text := FloatToStrF(NozzleDown, ffFixed, 10, 3);
  EditNozzlePickDown.Text := FloatToStrF(NozzlePickDown, ffFixed, 10, 3);
  EditNozzleChangerSpeed.Text := IntToStr(NozzleChangerSpeed);

  case NozzleChangerLocation of
    0:
      RadioButtonRight.Checked := true;
    1:
      RadioButtonFront.Checked := true;
    2:
      RadioButtonRear.Checked := true;
  end;

  GroupBoxNozzles.Enabled := NozzleChangerEnabled;

  EditCurrentNozzle.Text := IntToStr(CurrentNozzle);

  EditNozzle1X.Text := FloatToStrF(Nozzle1X, ffFixed, 10, 3);
  EditNozzle2X.Text := FloatToStrF(Nozzle2X, ffFixed, 10, 3);
  EditNozzle3X.Text := FloatToStrF(Nozzle3X, ffFixed, 10, 3);
  EditNozzle4X.Text := FloatToStrF(Nozzle4X, ffFixed, 10, 3);
  EditNozzle5X.Text := FloatToStrF(Nozzle5X, ffFixed, 10, 3);
  EditNozzle6X.Text := FloatToStrF(Nozzle6X, ffFixed, 10, 3);
  EditNozzle7X.Text := FloatToStrF(Nozzle7X, ffFixed, 10, 3);
  EditNozzle8X.Text := FloatToStrF(Nozzle8X, ffFixed, 10, 3);

  EditNozzle1Y.Text := FloatToStrF(Nozzle1Y, ffFixed, 10, 3);
  EditNozzle2Y.Text := FloatToStrF(Nozzle2Y, ffFixed, 10, 3);
  EditNozzle3Y.Text := FloatToStrF(Nozzle3Y, ffFixed, 10, 3);
  EditNozzle4Y.Text := FloatToStrF(Nozzle4Y, ffFixed, 10, 3);
  EditNozzle5Y.Text := FloatToStrF(Nozzle5Y, ffFixed, 10, 3);
  EditNozzle6Y.Text := FloatToStrF(Nozzle6Y, ffFixed, 10, 3);
  EditNozzle7Y.Text := FloatToStrF(Nozzle7Y, ffFixed, 10, 3);
  EditNozzle8Y.Text := FloatToStrF(Nozzle8Y, ffFixed, 10, 3);

  Enabled := true;

  UpdateButtons;
end;

procedure TFormNozzleChanger.RadioButtonFrontClick(Sender: TObject);
begin
  NozzleChangerLocation := 1;
  // 0 = right, 1 = front, 2 = back
  UpdateButtons;
end;

procedure TFormNozzleChanger.RadioButtonRearClick(Sender: TObject);
begin
  NozzleChangerLocation := 2;
  // 0 = right, 1 = front, 2 = rear
  UpdateButtons;
end;

procedure TFormNozzleChanger.RadioButtonRightClick(Sender: TObject);
begin
  NozzleChangerLocation := 0;
  // 0 = right, 1 = front, 2 = rear
  UpdateButtons;
end;

procedure TFormNozzleChanger.ButtonXPlus1Click(Sender: TObject);
begin
  JogX := 1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonYMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonYMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonYPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonYPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonZMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonZMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonZPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonZPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonJogAPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 1 / CNCAStepsPerRev * 360;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonJogXMinusClick(Sender: TObject);
begin
  JogX := -JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonJogXPlusClick(Sender: TObject);
begin
  JogX := JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonJogYMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := -JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonJogYPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonJogZMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonJogZPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonXMinus10Click(Sender: TObject);
begin
  JogX := -10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonXMinus1Click(Sender: TObject);
begin
  JogX := -1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleChanger.ButtonXPlus10Click(Sender: TObject);
begin
  JogX := 10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

end.
