unit NozzleOffset;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, UiTypes, Vcl.Mask;

type
  TFormNozzleOffset = class(TForm)
    ButtonClose: TBitBtn;
    GroupBoxNozzleOffset: TGroupBox;
    ButtonSetCamera: TButton;
    ButtonGotoNozzle: TButton;
    ButtonGotoCamera: TButton;
    EditY: TLabeledEdit;
    EditX: TLabeledEdit;
    EditZ: TLabeledEdit;
    ButtonSetNozzle: TButton;
    EditOffsetY: TLabeledEdit;
    EditOffsetX: TLabeledEdit;
    GroupBoxJogControl: TGroupBox;
    ButtonJogZMinus: TButton;
    ButtonJogZPlus: TButton;
    ButtonJogXMinus: TButton;
    ButtonJogYMinus: TButton;
    ButtonJogYPlus: TButton;
    ButtonJogXPlus: TButton;
    ButtonZMinus1: TButton;
    ButtonZPlus1: TButton;
    ButtonYMinus1: TButton;
    ButtonYPlus1: TButton;
    ButtonXMinus1: TButton;
    ButtonXPlus1: TButton;
    ButtonZMinus10: TButton;
    ButtonZPlus10: TButton;
    ButtonYMinus10: TButton;
    ButtonYPlus10: TButton;
    ButtonXMinus10: TButton;
    ButtonXPlus10: TButton;
    GroupBox1: TGroupBox;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton1: TRadioButton;
    GroupBox2: TGroupBox;
    ButtonSetPosition: TButton;
    ButtonUpCamera: TButton;
    Label1: TLabel;
    EditPositionX: TLabeledEdit;
    EditPositionY: TLabeledEdit;
    EditPositionZ: TLabeledEdit;
    GroupBoxCameraSelection: TGroupBox;
    RadioButtonUpCamera: TRadioButton;
    RadioButtonDownCamera: TRadioButton;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonGotoCameraClick(Sender: TObject);
    procedure ButtonGotoNozzleClick(Sender: TObject);
    procedure EditXChange(Sender: TObject);
    procedure EditYChange(Sender: TObject);
    procedure EditZChange(Sender: TObject);
    procedure EditXKeyPress(Sender: TObject; var Key: Char);
    procedure EditYKeyPress(Sender: TObject; var Key: Char);
    procedure EditZKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonSetCameraClick(Sender: TObject);
    procedure ButtonSetNozzleClick(Sender: TObject);
    procedure EditOffsetXChange(Sender: TObject);
    procedure EditOffsetYChange(Sender: TObject);
    procedure ButtonXPlus10Click(Sender: TObject);
    procedure ButtonXPlus1Click(Sender: TObject);
    procedure ButtonJogXPlusClick(Sender: TObject);
    procedure ButtonJogXMinusClick(Sender: TObject);
    procedure ButtonXMinus1Click(Sender: TObject);
    procedure ButtonXMinus10Click(Sender: TObject);
    procedure ButtonYPlus10Click(Sender: TObject);
    procedure ButtonYPlus1Click(Sender: TObject);
    procedure ButtonJogYPlusClick(Sender: TObject);
    procedure ButtonJogYMinusClick(Sender: TObject);
    procedure ButtonYMinus1Click(Sender: TObject);
    procedure ButtonYMinus10Click(Sender: TObject);
    procedure ButtonZPlus10Click(Sender: TObject);
    procedure ButtonZPlus1Click(Sender: TObject);
    procedure ButtonJogZPlusClick(Sender: TObject);
    procedure ButtonJogZMinusClick(Sender: TObject);
    procedure ButtonZMinus1Click(Sender: TObject);
    procedure ButtonZMinus10Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure RadioButton6Click(Sender: TObject);
    procedure RadioButton7Click(Sender: TObject);
    procedure RadioButton8Click(Sender: TObject);
    procedure ButtonUpCameraClick(Sender: TObject);
    procedure ButtonSetPositionClick(Sender: TObject);
    procedure EditPositionXChange(Sender: TObject);
    procedure EditPositionYChange(Sender: TObject);
    procedure EditPositionZChange(Sender: TObject);
    procedure RadioButtonDownCameraClick(Sender: TObject);
    procedure RadioButtonUpCameraClick(Sender: TObject);
  private
    { Private declarations }
    OldViewSelection: integer;
    procedure UpdateValues;
    procedure UpdateButtons;
  public
    { Public declarations }
  end;

var
  FormNozzleOffset: TFormNozzleOffset;

implementation

{$R *.dfm}

Uses
  Main, Settings, NozzleChanger, DeskWinCNC;

procedure TFormNozzleOffset.UpdateValues;
begin
  Enabled := False;

  EditPositionX.Text := FloatToStrF(UplookingCameraX, ffFixed, 10, 3);
  EditPositionY.Text := FloatToStrF(UplookingCameraY, ffFixed, 10, 3);
  EditPositionZ.Text := FloatToStrF(UplookingCameraZ, ffFixed, 10, 3);

  Enabled := True;
end;

procedure TFormNozzleOffset.UpdateButtons;
begin
  ButtonSetCamera.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSetNozzle.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoCamera.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoNozzle.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  GroupBoxJogControl.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  EditOffsetX.Text := FloatToStrF(NozzleOffsetX, ffFixed, 10, 3);
  EditOffsetY.Text := FloatToStrF(NozzleOffsetY, ffFixed, 10, 3);
  EditX.Text := FloatToStrF(NozzleCalibrateOffsetX, ffFixed, 10, 3);
  EditY.Text := FloatToStrF(NozzleCalibrateOffsetY, ffFixed, 10, 3);
  EditZ.Text := FloatToStrF(NozzleCalibrateOffsetZ, ffFixed, 10, 3);

  Enabled := False;

  case ViewSelection of // select required view
    0: // downlooking
      begin
        RadioButtonDownCamera.Checked := True;
      end;
    1: // uplooking
      begin
        RadioButtonUpCamera.Checked := True;
      end;
  end;
  Enabled := True;
end;

procedure TFormNozzleOffset.ButtonSetNozzleClick(Sender: TObject);
begin
  if MessageDlg('ARE YOU SURE YOU WANT TO SET THE NOZZLE OFFSET?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes then
  begin
    NozzleOffsetX := CNCXPos - CNCActualHomeX - NozzleCalibrateOffsetX;
    NozzleOffsetY := CNCYPos - CNCActualHomeY - NozzleCalibrateOffsetY;
    NozzleCalibrateOffsetZ := CNCZPos - CNCHomeZ;
    UpdateButtons;
  end;
end;

procedure TFormNozzleOffset.ButtonSetPositionClick(Sender: TObject);
begin
  ViewSelection := 1; // uplooking camera
  FormMain.UpdateStatus;
  UpdateButtons;

  if MessageDlg('ARE YOU SURE YOU WANT TO CHANGE THE CAMERA POSITION?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes then
  begin
    UplookingCameraX := CNCXPos - CNCActualHomeX;
    UplookingCameraY := CNCYPos - CNCActualHomeY;
    UpdateValues;
  end;

  if (UplookingCameraZ <> CNCZPos - CNCHomeZ) and
    (MessageDlg('"WARNING!! THE CAMERA HEIGHT HAS CHANGED' + #$0d + 'ARE YOU SURE YOU WANT TO' + #$0d + 'CHANGE THE CAMERA HEIGHT?', mtWarning, [mbYes, mbNo],
    0, mbYes) = mrYes) and (MessageDlg('LAST WARNING!!!' + #$0d + #$0d + 'DO YOU REALLY WANT TO' + #$0d + 'CHANGE THE CAMERA HEIGHT?', mtWarning, [mbYes, mbNo],
    0, mbYes) = mrYes) then
  begin
    UplookingCameraZ := CNCZPos - CNCHomeZ;
    UpdateValues;
  end;

  UpdateButtons;
end;

procedure TFormNozzleOffset.ButtonUpCameraClick(Sender: TObject);
begin
  ViewSelection := 1; // uplooking camera
  FormMain.UpdateStatus;
  UpdateButtons;

  FormMain.MoveHomeRelativeWithNozzleProtection(UplookingCameraX, UplookingCameraY, UplookingCameraZ, 0, CNCMaxStepsPerSecond);

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleOffset.ButtonSetCameraClick(Sender: TObject);
begin
  if MessageDlg('ARE YOU SURE YOU WANT TO CHANGE THE CAMERA POSITION?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes then
  begin
    NozzleCalibrateOffsetX := CNCXPos - CNCActualHomeX;
    NozzleCalibrateOffsetY := CNCYPos - CNCActualHomeY;
    UpdateButtons;
  end;
end;

procedure TFormNozzleOffset.EditXChange(Sender: TObject);
var
  V: Double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditX.Text);
      if (V + CNCActualHomeX >= CNCMinX) and (V + CNCActualHomeX <= CNCMaxX) then // restrict range
      begin
        NozzleCalibrateOffsetX := V;
        EditX.Color := clWindow; // normal colour
      end
      else
        EditX.Color := clRed; // error colour
    except
      EditX.Color := clRed; // error colour
    end;
  end;
end;

procedure TFormNozzleOffset.EditXKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormNozzleOffset.EditYChange(Sender: TObject);
var
  V: Double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditY.Text);
      if (V + CNCActualHomeY >= CNCMinY) and (V + CNCActualHomeY <= CNCMaxY) then // restrict range
      begin
        NozzleCalibrateOffsetY := V;
        EditY.Color := clWindow; // normal colour
      end
      else
        EditY.Color := clRed; // error colour
    except
      EditY.Color := clRed; // error colour
    end;
  end;
end;

procedure TFormNozzleOffset.EditYKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormNozzleOffset.EditZChange(Sender: TObject);
var
  V: Double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditZ.Text);
      if (V >= CNCMinZ) and (V <= CNCMaxZ) then // restrict range
      begin
        NozzleCalibrateOffsetZ := V;
        EditZ.Color := clWindow; // normal colour
      end
      else
        EditZ.Color := clRed; // error colour
    except
      EditZ.Color := clRed; // error colour
    end;
  end;
end;

procedure TFormNozzleOffset.EditZKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormNozzleOffset.ButtonGotoCameraClick(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  FormMain.UpdateStatus;
  UpdateButtons;

  FormMain.MoveHomeRelativeWithNozzleProtection(NozzleCalibrateOffsetX, NozzleCalibrateOffsetY, 0, 0, CNCMaxStepsPerSecond);
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleOffset.ButtonGotoNozzleClick(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  FormMain.UpdateStatus;

  FormMain.MoveHomeRelativeWithNozzleProtection(NozzleCalibrateOffsetX + NozzleOffsetX, NozzleCalibrateOffsetY + NozzleOffsetY, NozzleCalibrateOffsetZ, 0,
    CNCMaxStepsPerSecond);
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleOffset.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ViewSelection := OldViewSelection; // restore view

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;

  Save_Settings; // ensure the settings are saved first
end;

procedure TFormNozzleOffset.FormShow(Sender: TObject);
begin
  Self.Left := Screen.Width - Self.Width; // position at top right
  Self.Top := 0;

  OldViewSelection := ViewSelection; // preserve view

  ViewSelection := 0; // downlooking camera

  case NozzleOffsetNozzle of
    1:
      RadioButton1.Checked := true;
    2:
      RadioButton2.Checked := true;
    3:
      RadioButton3.Checked := true;
    4:
      RadioButton4.Checked := true;
    5:
      RadioButton5.Checked := true;
    6:
      RadioButton6.Checked := true;
    7:
      RadioButton6.Checked := true;
    8:
      RadioButton7.Checked := true;
  else
    RadioButton1.Checked := true;
  end;

  FormNozzleChanger.SelectNozzle(NozzleOffsetNozzle); // change nozzles

  ViewSelection := 0; // downlooking camera
  FormMain.UpdateStatus;

  FormMain.MoveHomeRelativeWithNozzleProtection(NozzleCalibrateOffsetX, NozzleCalibrateOffsetY, 0, 0, CNCMaxStepsPerSecond);

  UpdateValues;
  UpdateButtons;
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
end;

procedure TFormNozzleOffset.RadioButton1Click(Sender: TObject);
begin
  NozzleOffsetNozzle := 1;
  FormNozzleChanger.SelectNozzle(NozzleOffsetNozzle); // change nozzles
end;

procedure TFormNozzleOffset.RadioButton2Click(Sender: TObject);
begin
  NozzleOffsetNozzle := 2;
  FormNozzleChanger.SelectNozzle(NozzleOffsetNozzle); // change nozzles
end;

procedure TFormNozzleOffset.RadioButton3Click(Sender: TObject);
begin
  NozzleOffsetNozzle := 3;
  FormNozzleChanger.SelectNozzle(NozzleOffsetNozzle); // change nozzles
end;

procedure TFormNozzleOffset.RadioButton4Click(Sender: TObject);
begin
  NozzleOffsetNozzle := 4;
  FormNozzleChanger.SelectNozzle(NozzleOffsetNozzle); // change nozzles
end;

procedure TFormNozzleOffset.RadioButton5Click(Sender: TObject);
begin
  NozzleOffsetNozzle := 5;
  FormNozzleChanger.SelectNozzle(NozzleOffsetNozzle); // change nozzles
end;

procedure TFormNozzleOffset.RadioButton6Click(Sender: TObject);
begin
  NozzleOffsetNozzle := 6;
  FormNozzleChanger.SelectNozzle(NozzleOffsetNozzle); // change nozzles
end;

procedure TFormNozzleOffset.RadioButton7Click(Sender: TObject);
begin
  NozzleOffsetNozzle := 7;
  FormNozzleChanger.SelectNozzle(NozzleOffsetNozzle); // change nozzles
end;

procedure TFormNozzleOffset.RadioButton8Click(Sender: TObject);
begin
  NozzleOffsetNozzle := 8;
  FormNozzleChanger.SelectNozzle(NozzleOffsetNozzle); // change nozzles
end;

procedure TFormNozzleOffset.RadioButtonDownCameraClick(Sender: TObject);
begin
  if Enabled then
    ViewSelection := 0; // downlooking camera

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleOffset.RadioButtonUpCameraClick(Sender: TObject);
begin
  if Enabled then
    ViewSelection := 1; // uplooking camera

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormNozzleOffset.EditOffsetXChange(Sender: TObject);
var
  V: Double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditOffsetX.Text);
      if (V >= -100) and (V <= 100) then // restrict range
      begin
        NozzleOffsetX := V;
        EditOffsetX.Color := clWindow; // normal colour
      end
      else
        EditOffsetX.Color := clRed; // error colour
    except
      EditOffsetX.Color := clRed; // error colour
    end;
  end;
end;

procedure TFormNozzleOffset.EditOffsetYChange(Sender: TObject);
var
  V: Double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditOffsetY.Text);
      if (V >= -100) and (V <= 100) then // restrict range
      begin
        NozzleOffsetY := V;
        EditOffsetY.Color := clWindow; // normal colour
      end
      else
        EditOffsetY.Color := clRed; // error colour
    except
      EditOffsetY.Color := clRed; // error colour
    end;
  end;
end;

procedure TFormNozzleOffset.EditPositionXChange(Sender: TObject);
var
  V: Double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditPositionX.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        UplookingCameraX := V;
        EditPositionX.Color := clWindow; // normal colour
      end
      else
        EditPositionX.Color := clRed; // error colour
    except
      EditPositionX.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleOffset.EditPositionYChange(Sender: TObject);
var
  V: Double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditPositionY.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        UplookingCameraY := V;
        EditPositionY.Color := clWindow; // normal colour
      end
      else
        EditPositionY.Color := clRed; // error colour
    except
      EditPositionY.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleOffset.EditPositionZChange(Sender: TObject);
var
  V: Double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditPositionZ.Text);
      if (V >= CNCMinZ - CNCHomeZ) and (V <= CNCMaxZ - CNCHomeZ) then // restrict range
      begin
        UplookingCameraZ := V;
        EditPositionZ.Color := clWindow; // normal colour
      end
      else
        EditPositionZ.Color := clRed; // error colour
    except
      EditPositionZ.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormNozzleOffset.ButtonXPlus1Click(Sender: TObject);
begin
  JogX := 1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonYMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonYMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonYPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonYPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonZMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonZMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonZPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonZPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonJogXMinusClick(Sender: TObject);
begin
  JogX := -JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonJogXPlusClick(Sender: TObject);
begin
  JogX := JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonJogYMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := -JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonJogYPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonJogZMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonJogZPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonXMinus10Click(Sender: TObject);
begin
  JogX := -10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonXMinus1Click(Sender: TObject);
begin
  JogX := -1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormNozzleOffset.ButtonXPlus10Click(Sender: TObject);
begin
  JogX := 10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

end.
