unit ReferenceSelect;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TFormReferenceSelect = class(TForm)
    PanelReference: TPanel;
    ImageMain: TImage;
    PanelReferenceBoxLeft: TPanel;
    PanelReferenceBoxRight: TPanel;
    PanelReferenceBoxTop: TPanel;
    PanelReferenceBoxBottom: TPanel;
    PanelReferenceCrosshairX: TPanel;
    PanelReferenceCrosshairY: TPanel;
    ButtonOk: TBitBtn;
    ButtonCancel: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure ImageMainMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormReferenceSelect: TFormReferenceSelect;

implementation

{$R *.dfm}

procedure TFormReferenceSelect.FormShow(Sender: TObject);
begin
  // show crosshairs centred on reference image
  PanelReferenceCrossHairX.Left := ImageMain.Left;
  PanelReferenceCrossHairX.Top := ImageMain.Top + (ImageMain.Height div 2);
  PanelReferenceCrossHairX.Width := ImageMain.Width;
  PanelReferenceCrossHairX.Height := 1;

  PanelReferenceCrossHairY.Top := ImageMain.Top;
  PanelReferenceCrossHairY.Left := ImageMain.Left + (ImageMain.Width div 2);
  PanelReferenceCrossHairY.Height := ImageMain.Height;
  PanelReferenceCrossHairY.Width := 1;
end;

procedure TFormReferenceSelect.ImageMainMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  CentreX, CentreY, Width, Height: integer;
begin
  // show box centred on reference image
  CentreX := ImageMain.Width div 2;
  CentreY := ImageMain.Height div 2;

  Width := Abs((X - CentreX) * 2);
  Height := Abs((Y - CentreY) * 2);
  if Width > Round(ImageMain.Width * 0.90) then
    Width := Round(ImageMain.Width * 0.90);
  if Width < Round(ImageMain.Width * 0.05) then
    Width := Round(ImageMain.Width * 0.05);
  if Height > Round(ImageMain.Height * 0.90) then
    Height := Round(ImageMain.Height * 0.90);
  if Height < Round(ImageMain.Height * 0.05) then
    Height := Round(ImageMain.Height * 0.05);

  PanelReferenceBoxLeft.Left := CentreX - (Width div 2);
  PanelReferenceBoxLeft.Width := 1;
  PanelReferenceBoxLeft.Top := CentreY - (Height div 2);
  PanelReferenceBoxLeft.Height := Height;

  PanelReferenceBoxRight.Left := CentreX + (Width div 2);
  PanelReferenceBoxRight.Width := 1;
  PanelReferenceBoxRight.Top := CentreY - (Height div 2);
  PanelReferenceBoxRight.Height := Height;

  PanelReferenceBoxTop.Left := CentreX - (Width div 2);
  PanelReferenceBoxTop.Width := Width;
  PanelReferenceBoxTop.Top := CentreY - (Height div 2);
  PanelReferenceBoxTop.Height := 1;

  PanelReferenceBoxBottom.Left := CentreX - (Width div 2);
  PanelReferenceBoxBottom.Width := Width;
  PanelReferenceBoxBottom.Top := CentreY + (Height div 2);
  PanelReferenceBoxBottom.Height := 1;

  PanelReferenceBoxLeft.Visible := true;
  PanelReferenceBoxRight.Visible := true;
  PanelReferenceBoxTop.Visible := true;
  PanelReferenceBoxBottom.Visible := true;
end;

end.
