unit RejectTray;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Vcl.Mask;

type
  TFormRejectTray = class(TForm)
    ButtonClose: TBitBtn;
    GroupBoxRejectTrays: TGroupBox;
    EditTray1Y: TLabeledEdit;
    EditTray1X: TLabeledEdit;
    EditTray2Y: TLabeledEdit;
    EditTray2X: TLabeledEdit;
    EditTray3Y: TLabeledEdit;
    EditTray3X: TLabeledEdit;
    EditTray4Y: TLabeledEdit;
    EditTray4X: TLabeledEdit;
    EditTray5Y: TLabeledEdit;
    EditTray5X: TLabeledEdit;
    ButtonSetTray1: TButton;
    ButtonGotoTray1: TButton;
    ButtonGotoTray2: TButton;
    ButtonSetTray2: TButton;
    ButtonGotoTray3: TButton;
    ButtonSetTray3: TButton;
    ButtonGotoTray4: TButton;
    ButtonSetTray4: TButton;
    ButtonGotoTray5: TButton;
    ButtonSetTray5: TButton;
    GroupBoxJogControl: TGroupBox;
    ButtonJogZMinus: TButton;
    ButtonJogZPlus: TButton;
    ButtonJogXMinus: TButton;
    ButtonJogYMinus: TButton;
    ButtonJogYPlus: TButton;
    ButtonJogXPlus: TButton;
    ButtonZMinus1: TButton;
    ButtonZPlus1: TButton;
    ButtonYMinus1: TButton;
    ButtonYPlus1: TButton;
    ButtonXMinus1: TButton;
    ButtonXPlus1: TButton;
    ButtonZMinus10: TButton;
    ButtonZPlus10: TButton;
    ButtonYMinus10: TButton;
    ButtonYPlus10: TButton;
    ButtonXMinus10: TButton;
    ButtonXPlus10: TButton;
    procedure EditTray1XChange(Sender: TObject);
    procedure EditTray2XChange(Sender: TObject);
    procedure EditTray3XChange(Sender: TObject);
    procedure EditTray4XChange(Sender: TObject);
    procedure EditTray5XChange(Sender: TObject);
    procedure EditTray1YChange(Sender: TObject);
    procedure EditTray2YChange(Sender: TObject);
    procedure EditTray3YChange(Sender: TObject);
    procedure EditTray4YChange(Sender: TObject);
    procedure EditTray5YChange(Sender: TObject);
    procedure ButtonGotoTray1Click(Sender: TObject);
    procedure ButtonGotoTray2Click(Sender: TObject);
    procedure ButtonGotoTray3Click(Sender: TObject);
    procedure ButtonGotoTray4Click(Sender: TObject);
    procedure ButtonGotoTray5Click(Sender: TObject);
    procedure ButtonSetTray1Click(Sender: TObject);
    procedure ButtonSetTray2Click(Sender: TObject);
    procedure ButtonSetTray3Click(Sender: TObject);
    procedure ButtonSetTray4Click(Sender: TObject);
    procedure ButtonSetTray5Click(Sender: TObject);
    procedure ButtonXPlus10Click(Sender: TObject);
    procedure ButtonXPlus1Click(Sender: TObject);
    procedure ButtonJogXPlusClick(Sender: TObject);
    procedure ButtonJogXMinusClick(Sender: TObject);
    procedure ButtonXMinus1Click(Sender: TObject);
    procedure ButtonXMinus10Click(Sender: TObject);
    procedure ButtonYPlus10Click(Sender: TObject);
    procedure ButtonYPlus1Click(Sender: TObject);
    procedure ButtonJogYPlusClick(Sender: TObject);
    procedure ButtonJogYMinusClick(Sender: TObject);
    procedure ButtonYMinus1Click(Sender: TObject);
    procedure ButtonYMinus10Click(Sender: TObject);
    procedure ButtonZPlus10Click(Sender: TObject);
    procedure ButtonZPlus1Click(Sender: TObject);
    procedure ButtonJogZPlusClick(Sender: TObject);
    procedure ButtonJogZMinusClick(Sender: TObject);
    procedure ButtonZMinus1Click(Sender: TObject);
    procedure ButtonZMinus10Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure UpdateValues;
    procedure UpdateButtons;
  public
    { Public declarations }
  end;

var
  FormRejectTray: TFormRejectTray;

implementation

{$R *.dfm}

uses
  DeskWinCNC, Settings, Main;

procedure TFormRejectTray.ButtonGotoTray1Click(Sender: TObject);
begin
  FormMain.MoveHomeRelativeWithNozzleProtection(RejectTray1X, RejectTray1Y, 0, 0, CNCMaxStepsPerSecond);

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormRejectTray.ButtonGotoTray2Click(Sender: TObject);
begin
  FormMain.MoveHomeRelativeWithNozzleProtection(RejectTray2X, RejectTray2Y, 0, 0, CNCMaxStepsPerSecond);

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormRejectTray.ButtonGotoTray3Click(Sender: TObject);
begin
  FormMain.MoveHomeRelativeWithNozzleProtection(RejectTray3X, RejectTray3Y, 0, 0, CNCMaxStepsPerSecond);

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormRejectTray.ButtonGotoTray4Click(Sender: TObject);
begin
  FormMain.MoveHomeRelativeWithNozzleProtection(RejectTray4X, RejectTray4Y, 0, 0, CNCMaxStepsPerSecond);

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormRejectTray.ButtonGotoTray5Click(Sender: TObject);
begin
  FormMain.MoveHomeRelativeWithNozzleProtection(RejectTray5X, RejectTray5Y, 0, 0, CNCMaxStepsPerSecond);

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormRejectTray.ButtonSetTray1Click(Sender: TObject);
begin
  RejectTray1X := CNCXPos - CNCActualHomeX;
  RejectTray1Y := CNCYPos - CNCActualHomeY;

  UpdateValues;
  UpdateButtons;
end;

procedure TFormRejectTray.ButtonSetTray2Click(Sender: TObject);
begin
  RejectTray2X := CNCXPos - CNCActualHomeX;
  RejectTray2Y := CNCYPos - CNCActualHomeY;

  UpdateValues;
  UpdateButtons;
end;

procedure TFormRejectTray.ButtonSetTray3Click(Sender: TObject);
begin
  RejectTray3X := CNCXPos - CNCActualHomeX;
  RejectTray3Y := CNCYPos - CNCActualHomeY;

  UpdateValues;
  UpdateButtons;
end;

procedure TFormRejectTray.ButtonSetTray4Click(Sender: TObject);
begin
  RejectTray4X := CNCXPos - CNCActualHomeX;
  RejectTray4Y := CNCYPos - CNCActualHomeY;

  UpdateValues;
  UpdateButtons;
end;

procedure TFormRejectTray.ButtonSetTray5Click(Sender: TObject);
begin
  RejectTray5X := CNCXPos - CNCActualHomeX;
  RejectTray5Y := CNCYPos - CNCActualHomeY;

  UpdateValues;
  UpdateButtons;
end;

procedure TFormRejectTray.EditTray1XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditTray1X.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        RejectTray1X := V;
        EditTray1X.Color := clWindow; // normal colour
      end
      else
        EditTray1X.Color := clRed; // error colour
    except
      EditTray1X.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormRejectTray.EditTray1YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditTray1Y.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        RejectTray1Y := V;
        EditTray1Y.Color := clWindow; // normal colour
      end
      else
        EditTray1Y.Color := clRed; // error colour
    except
      EditTray1Y.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormRejectTray.EditTray2XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditTray2X.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        RejectTray2X := V;
        EditTray2X.Color := clWindow; // normal colour
      end
      else
        EditTray2X.Color := clRed; // error colour
    except
      EditTray2X.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormRejectTray.EditTray2YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditTray2Y.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        RejectTray2Y := V;
        EditTray2Y.Color := clWindow; // normal colour
      end
      else
        EditTray2Y.Color := clRed; // error colour
    except
      EditTray2Y.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormRejectTray.EditTray3XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditTray3X.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        RejectTray3X := V;
        EditTray3X.Color := clWindow; // normal colour
      end
      else
        EditTray3X.Color := clRed; // error colour
    except
      EditTray3X.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormRejectTray.EditTray3YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditTray3Y.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        RejectTray3Y := V;
        EditTray3Y.Color := clWindow; // normal colour
      end
      else
        EditTray3Y.Color := clRed; // error colour
    except
      EditTray3Y.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormRejectTray.EditTray4XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditTray4X.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        RejectTray4X := V;
        EditTray4X.Color := clWindow; // normal colour
      end
      else
        EditTray4X.Color := clRed; // error colour
    except
      EditTray4X.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormRejectTray.EditTray4YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditTray4Y.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        RejectTray4Y := V;
        EditTray4Y.Color := clWindow; // normal colour
      end
      else
        EditTray4Y.Color := clRed; // error colour
    except
      EditTray4Y.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormRejectTray.EditTray5XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditTray5X.Text);
      if (V >= CNCMinX - CNCActualHomeX) and (V <= CNCMaxX - CNCActualHomeX) then // restrict range
      begin
        RejectTray5X := V;
        EditTray5X.Color := clWindow; // normal colour
      end
      else
        EditTray5X.Color := clRed; // error colour
    except
      EditTray5X.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormRejectTray.EditTray5YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditTray5Y.Text);
      if (V >= CNCMinY - CNCActualHomeY) and (V <= CNCMaxY - CNCActualHomeY) then // restrict range
      begin
        RejectTray5Y := V;
        EditTray5Y.Color := clWindow; // normal colour
      end
      else
        EditTray5Y.Color := clRed; // error colour
    except
      EditTray5Y.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormRejectTray.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Save_Settings; // ensure the settings are saved first
end;

procedure TFormRejectTray.FormShow(Sender: TObject);
begin
  Self.Left := Screen.Width - Self.Width; // position at top right
  Self.Top := 0;

  UpdateValues;
  UpdateButtons;
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
end;

procedure TFormRejectTray.UpdateValues;
begin
  Enabled := false;

  EditTray1X.Text := FloatToStrF(RejectTray1X, ffFixed, 10, 3);
  EditTray2X.Text := FloatToStrF(RejectTray2X, ffFixed, 10, 3);
  EditTray3X.Text := FloatToStrF(RejectTray3X, ffFixed, 10, 3);
  EditTray4X.Text := FloatToStrF(RejectTray4X, ffFixed, 10, 3);
  EditTray5X.Text := FloatToStrF(RejectTray5X, ffFixed, 10, 3);

  EditTray1Y.Text := FloatToStrF(RejectTray1Y, ffFixed, 10, 3);
  EditTray2Y.Text := FloatToStrF(RejectTray2Y, ffFixed, 10, 3);
  EditTray3Y.Text := FloatToStrF(RejectTray3Y, ffFixed, 10, 3);
  EditTray4Y.Text := FloatToStrF(RejectTray4Y, ffFixed, 10, 3);
  EditTray5Y.Text := FloatToStrF(RejectTray5Y, ffFixed, 10, 3);

  Enabled := true;
end;

procedure TFormRejectTray.UpdateButtons;
begin
  GroupBoxJogControl.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonSetTray1.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSetTray2.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSetTray3.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSetTray4.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSetTray5.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonGotoTray1.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoTray2.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoTray3.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoTray4.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoTray5.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
end;

procedure TFormRejectTray.ButtonXPlus1Click(Sender: TObject);
begin
  JogX := 1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonYMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonYMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonYPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonYPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonZMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonZMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonZPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonZPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonJogXMinusClick(Sender: TObject);
begin
  JogX := -JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonJogXPlusClick(Sender: TObject);
begin
  JogX := JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonJogYMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := -JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonJogYPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonJogZMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonJogZPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonXMinus10Click(Sender: TObject);
begin
  JogX := -10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonXMinus1Click(Sender: TObject);
begin
  JogX := -1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormRejectTray.ButtonXPlus10Click(Sender: TObject);
begin
  JogX := 10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

end.
